;()  ,  2009

SYSREG_FF	.equ	0FF7Fh
SYSREG_FA	.equ	0FA7Fh
SYSREG_BF	.equ	0BF7Fh
LUT		.equ	0FAFBh
VIREG		.equ	0FB3Ah
NCREG		.equ	0BFBFh
KBBASE2	.equ	0F800H
KB06		.equ	KBBASE2+40h    ;            
;  
KB08		.equ	KBBASE2+101h    ;     7   6   5   4   3   2   1   0
KB09		.equ	KBBASE2+102h    ;         .                   9   8
SICP0		.equ	0FB28h

SOUNDD	.equ	0FB00h
SOUNDM	.equ	0FB03h
SOUNDC	.equ	0FB32h


CTtmp		.equ	9000h
PGTCT		.equ	0A000h
PGTCThi	.equ	0A0h
PNT		.equ	9C00h

logow		.equ	24
logoh		.equ	15

Init:
		di
		lxi	sp,100h
		mvi	a,1Ch
		sta	SYSREG_FF
		sta	SYSREG_FA
		mvi	a,20h			;  
		sta	VIREG
; 
		lxi   h, LUT
		mvi	m,00000000b+0	;0-
		mvi	m,00010000b+1	;1-
		mvi	m,00100000b+2	;2-
		mvi	m,00110000b+3	;3-
		mvi	m,01000000b+4	;4-
		mvi	m,11010000b+5	;5--
		mvi	m,01100000b+6	;6-
		mvi	m,11110000b+7	;7-

		lxi	h,0FC00h
		xra	a
ClsText:	mov	m,a
		inx	h
		cmp	h
		jnz	ClsText

		mvi	a,6Ch
		sta	SYSREG_FA	;    
		mvi	a,80h		; ,  0 ( )
		sta	NCREG

		lxi	h,0C000h
		xra	a
ClsGraph:	mvi	m,0FFh
		inx	h
		cmp	h
		jnz	ClsGraph

		mvi	a, 6*2+80h	; ,  6-
		sta	NCREG
		lxi	h,Logo
		lxi	d,0FC14h
DrwLogo:
		mvi	b,logow
logo2:	push	d
		mvi	c,logoh
logo1:
		mov	a,m
		stax	d
		mov	a,e
		sui	64
		mov	e,a
		mov	a,d
		sbi	0
		mov	d,a
		inx	h
		dcr	c
		jnz	logo1
		pop	d
		inx	d
		dcr	b
		jnz	logo2

		mvi	a,1Ch
		sta	SYSREG_BF


;  
		lxi	h,ram_E000
		lxi	b,0C000h-ram_E000
ClrPNT:	mvi	m,0
		inx	h
		dcx	b
		mov	a,b
		ora	c
		jnz	ClrPNT

		lxi	h,BeginFastMov
		lxi	d,22E1h
		lxi	b,384
GenFM1:
		mov	m,e
		inx	h
		mov	m,d
		inx	h
		inx	h
		inx	h
		dcx	b
		mov	a,b
		ora	c
		jnz	GenFM1

		lxi	h,BeginFastMov+2
		lxi	d,ram_E000
		lxi	b,384
GenFM2:
		mov	m,e
		inx	h
		mov	m,d
		inx	h
		inx	h
		inx	h
		inx	d
		inx	d
		dcx	b
		mov	a,b
		ora	c
		jnz	GenFM2

; 
		mvi	a,8
		sta	SOUNDC

		mvi	a,0C3h
		sta	0F7F0h
		sta	0F7FCh
		lxi	h,SoundProcInt
		shld	0F7F0h+1
		lxi	h,UInt
		shld	0F7FCh+1		
		ei

		jmp	ModStart


UInt:
		push	psw
		mvi	a,20h
		sta	SICP0
		pop	psw
		ei
		ret

;   CT
FILVRM:
L0056:
		push	h
		push	d
		push	psw
		call	ClrTrans
		mov	e,a
FILVRMLoop:
		mov	m,e
		inx	h
		dcx	b
		mov	a,c
		ora	b
		jnz	FILVRMLoop
		pop	psw
		pop	d
		pop	h
		ret

;  msx-> (   )
ClrTrans:
		push	b
		push	d
		push	h

		rrc
		rrc
		rrc
		rrc
		ani	00001111b
		lxi	h,ClrTab
		add	l
		mov	l,a
		mov	a,h
		aci	0
		mov	h,a
		mov	a,m		; 
		rlc

		pop	h
		pop	d
		pop	b
		ret

ClrTab:
		.db 0		;0  msx -  (0)  
		.db 0		;1  msx -  (0)  
		.db 2		;2  msx - -  (2)  
		.db 2		;3  msx - -  (2)  
		.db 1		;4  msx - - (1)  
		.db 1		;5  msx - - (1)  
		.db 4		;6  msx  -  (4)  
		.db 3		;7  msx -  (3)  
		.db 4		;8  msx -  (4)  
		.db 4		;9  msx  - (4)  
		.db 6		;10  msx -  (6)  
		.db 6		;11  msx - - (6)  
		.db 2		;12  msx -  (2)  
		.db 5		;13  msx  - (5)  
		.db 7		;14  msx  - (7)  
		.db 7		;15  msx  - (7)  

SNSMAT:
		cpi	8
		jz	SNSMAT8
		mvi	a,0FFh
		ret
SNSMAT8:	
		push	h
		lxi	h,MSXKey
		mvi	m,0FFh
; 
		lda	KB06
		ani	10000000b
		jz	ChkDwn
SPACE:	mov	a,m
		ani	11111110b
		mov	m,a
ChkDwn:
		lda	KB08
		ani	00000100b
		jz	ChkRight
CurDwn:	mov	a,m
		ani	10111111b
		mov	m,a
ChkRight:
		lda	KB08
		ani	01000000b
		jz	ChkUp
CurRight:	mov	a,m
		ani	01111111b
		mov	m,a
ChkUp:
		lda	KB09
		ani	00000001b
		jz	ChkLeft
CurUp:	mov	a,m
		ani	11011111b
		mov	m,a
ChkLeft:
		lda	KB08
		ani	00010000b
		jz	SNSMATout
CurLeft:	mov	a,m
		ani	11101111b
		mov	m,a
SNSMATout:	mov	a,m
		pop	h
		ret
MSXKey:	.db	0FFh

GTSTCK:
L00D5:
		mvi     a, 8
		call    SNSMAT
		rrc
		rrc
		rrc
		rrc
		lxi     h, KeybDir
		ani     00001111b
		mov     e, a
		mvi     d, 0
		dad     d
		mov     a, m
		ret
KeybDir:
		.db    0,   3,   5,   4
		.db    1,   2,   0,   3
		.db    7,   0,   6,   5
		.db    8,   1,   7,   0

GTTRIG:
L00D8:
		mvi     a, 8
		call    SNSMAT
		cma
		ani     1
		rz
		mvi	a,0FFh
		ret

.include "VI53.asm"

Logo:
		.db    0,   4,	 4,   6,   5,	4,   4,	  0,   0,   0,	 0,   0,   0,	0,   0,	  0
		.db 0B9h,0A5h,0B9h,0A5h,0B8h, 80h,   0,	  0,   0,   0,	 0,   0,   0,	0,   0,	29h
		.db 0E9h, 2Fh, 29h,0C9h,   0,	0,   0,	  0,   0,   0,	 0,   0,   0,	0,   8,	  8
		.db    8,   8,	 8, 0Fh,   0,	0,   0,	  0,   0,   0,	 0,   0,   2, 32h, 4Bh,	4Ah
		.db  4Ah, 33h,	 0,   0,   0, 73h, 4Ah,	4Bh, 72h, 4Bh, 70h,   0, 0Ch, 92h, 52h,	52h
		.db  8Ch,   0,	 0, 10h,0D0h, 1Ch, 92h,	12h,0DCh,   0, 88h,0FBh, 52h, 53h, 52h,	33h
		.db    0,   0,	 0, 64h, 96h, 85h, 94h,	64h,   0,   1,0DFh, 12h, 92h, 12h,0D2h,	  0
		.db    0,   0,0A4h, 9Ch,0A4h,0A4h, 9Ch,	  0,   0, 4Ah, 53h, 62h, 52h, 4Ah,   0,	  0
		.db  22h, 3Eh, 14h, 14h, 14h, 0Ch,   0,	  0, 52h, 5Ah,0D6h, 52h, 52h,	0, 0Ch,	  0
		.db  94h, 93h, 94h, 54h, 33h,	0,   0,	12h, 1Ah, 16h, 12h, 12h,   0,	0,   0,	84h
		.db  84h, 84h, 84h, 84h,   7,	0, 12h,	12h, 1Eh, 12h, 12h, 0Ch,   0,	0,0A4h,0A4h
		.db 0A8h,0B0h,0A8h,0A4h,   0, 97h, 94h,	97h, 54h, 37h,	 0,   0,   0,	4,   4,	  5
		.db    6, 55h, 54h,   0,0A4h, 29h, 31h,	29h,0A4h,   0,	 0,   1, 99h,0A5h, 25h,	25h
		.db  19h, 80h,	 0,0C9h, 2Fh,	9, 29h,0C6h,   0,   0,	 0, 0Eh,0C9h, 2Eh, 29h,0CEh
		.db    0,   2, 4Bh, 49h, 79h, 49h, 48h,	  0,   0,   0, 78h, 40h, 70h, 40h, 7Bh,	  0
		.db  28h,0E8h, 4Eh, 49h, 49h,0CEh,   0,	  0,   0, 80h, 80h, 80h, 80h,0EAh, 0Ah,	  0
		.db    2,   2,	 2,   2,   2, 0Fh,   0,	  0, 0Fh,   4,	 2,   1,   9,	6,   0,	25h
		.db  35h, 2Dh, 25h, 25h, 80h,	0,   0,	31h, 4Ah, 4Ah, 4Ah, 4Ah, 31h,	0, 13h,	14h
		.db  54h,0B4h, 13h,   0,   0,	0, 8Ch,	42h, 4Eh, 52h, 52h, 8Ch,   0, 3Eh,0AAh,0AAh
		.db 0AAh, 22h,	 0,   0,   0,	0,   0,	  0,   0,   0,	 0,   0,0F4h, 84h,0E7h,	84h
		.db 0F4h,   0,	 0,   0,   0,	0,   0,	  0,   0,   0,	 0,0A4h,0A9h,0B1h,0A9h,0A4h
		.db    0,   0,	 0,   0,   0,	0,   0,	  0,   0,   0,0C0h, 20h, 20h, 20h,0C0h,	  0
		.db    0,   0,	 0,   0,   0,	0,   0,	  0