;()  ,  2009
;    ""  -06

WRTPSG:
L0093:
		push	psw
		push	h
		push	d
		lxi	h, AYmainJmpTable

WRTPSG_dispatch:
		ani	0Fh
		add	a
		call	add_hl_a
		mov	d, m
		inx	h
		mov	h, m
		mov	l, d
		pchl
; End of function WRTPSG

AYmainJmpTable:	.dw AY00,AY01,AY02,AY03
			.dw AY04,AY05,AY1415,AY07
			.dw AY08,AY09,AY10,AY11
			.dw AY12,AY13,AY1415,AY1415

;	8    A

AY00:
		mov	a, e
		sta	AY_R0
		call	SetFreqTimerCh0
		jmp	AY1415

; 4 		 A

AY01:
		mov	a, e
		sta	AY_R1
		call	SetFreqTimerCh0
		jmp	AY1415
;		  0 

SetFreqTimerCh0:
		lxi	h, AY_R0
		call	FreqAY_to_VI53
		mov	a, l
;		sta	SOUNDD
		mov	a, h
;		sta	SOUNDD
		ret
; End of function SetFreqTimerCh0

;   AY    53
FreqAY_to_VI53:
		mov	a, m
		inx	h
		mov	h, m
		mov	l, a
		mvi	a,00001111b
		ana	h
		mov	h, a

Not0Freq:
; ,    18,    
		dad	h	;*2
;		mov	e, l
;		mov	d, h
		dad	h	;*4
		dad	h	;*8
		dad	h	;*16
;		dad	d	;*18
		ret
; End of function FreqAY_to_VI53

;	8    B

AY02:
		mov	a, e
		sta	AY_R2
		call	SetFreqTimerCh1
		jmp	AY1415
; 4 		 B

AY03:
		mov	a, e
		sta	AY_R3
		call	SetFreqTimerCh1
		jmp	AY1415

SetFreqTimerCh1:
		lxi	h, AY_R2
		call	FreqAY_to_VI53
		mov	a, l
		sta	SOUNDD
		mov	a, h
		sta	SOUNDD
		ret

;	8    C

AY04:
		mov	a, e
		sta	AY_R4
		call	SetFreqTimerCh2
		jmp	AY1415

; 4 		 C

AY05:
		mov	a, e
		sta	AY_R5
		call	SetFreqTimerCh2
		jmp	AY1415

;		  2 

SetFreqTimerCh2:
		lxi	h, AY_R4
		call	FreqAY_to_VI53
		mov	a, l
;		sta	SOUNDD
		mov	a, h
;		sta	SOUNDD
		ret
; End of function SetFreqTimerCh2

;	8    

AY11:
		jmp	AY1415

; 8    
AY12:
		mov	a, e
		sta	AY_R12
		jmp	AY1415

;  
AY13:
		mvi	a,00001111b
		ana	e
		sta	AY_R13
		jmp	AY1415

;   
;AY06:

; 

AY07:
		call	AY07sub
;  /

AY1415:
		pop	d
		pop	h
		pop	psw
subAY07_000:
		ret

AY07sub:
		mov	a, e
		ani	111000b
		cpi	111000b		;     	?
		jnz	Noise		;   
		lxi	h, AY_R7_Noise
		mvi	m, 0		;   ,   0

MergNoisAndTon:
		rrc
		rrc
		rrc			;   /  
					;   3 
		ora	e		;   /    
					;  .	3 
		mov	e, a
		lda	AY_R7_Process
		xra	e		; ,  	
		lxi	h, AY07JmpTab
		ani	111b
		jmp	WRTPSG_dispatch

Noise:
		sta	AY_R7_Noise
		jmp	MergNoisAndTon
; End of function AY07sub

AY07JmpTab:	.dw subAY07_000,subAY07_001,subAY07_010,subAY07_011
		.dw subAY07_100,subAY07_101,subAY07_110,subAY07_111
;  A



subAY07_001:
		mov	a, e
		sta	AY_R7_Process
; End of function subAY07_001


TimerCh0:
		ani	001b
		jz	SetFreqTimerCh0
;		mvi	a, 36h		;   0 
		sta	SOUNDM
		ret
; End of function TimerCh0

;  B


subAY07_010:
		mov	a, e
		sta	AY_R7_Process
; End of function subAY07_010


TimerCh1:
		ani	010b
		jz	SetFreqTimerCh1
		mvi	a, 36h		;   1 
		sta	SOUNDM
		ret
; End of function TimerCh1

;  C

subAY07_100:
		mov	a, e
		sta	AY_R7_Process

TimerCh2:
		ani	100b
		jz	SetFreqTimerCh2
		mvi	a, 36h		;   2 
;		sta	SOUNDM
		ret
; End of function TimerCh2

subAY07_011:
		call	subAY07_001
		jmp	subAY07_010

subAY07_101:
		call	subAY07_001
		jmp	subAY07_100

subAY07_110:
		call	subAY07_010
		jmp	subAY07_100

subAY07_111:
		call	subAY07_001
		jmp	subAY07_110

;  A
AY08:
		mov	a, e
		ani	10000b	;      A
		sta	AY_R8
		jnz	Envelope	;    
		mov	a, e
		ani	1111b		;  
		cpi	3
		mvi	a, 1111b	;  
		jc	SetTimerCh0	;   A<3 (0-2)  	
		mvi	a, 0		;   

SetTimerCh0:
		call	TimerCh0
		jmp	AY1415

Envelope:
		lda	AY_R12
		rrc
		rrc
		rrc
		ani	11110b		;     4	  
		inr	a
		sta	EnvPeriod
		sta	EnvPeriodCount
		call	SetFreqTimerCh0
		jmp	AY1415

;  B

AY09:
		mov	a, e
		ani	10000b
		sta	AY_R9
		jnz	Envelope
		mov	a, e
		ani	1111b
		cpi	0011b
		mvi	a, 1111b
		jc	SetTimerCh1
		mvi	a, 0

SetTimerCh1:
		call	TimerCh1
		jmp	AY1415

;  C
AY10:
		mov	a, e
		ani	10000b
		sta	AY_R10
		jnz	Envelope
		mov	a, e
		ani	1111b
		cpi	11b
		mvi	a, 0Fh
		jc	SetTimerCh2
		mvi	a, 0

SetTimerCh2:
		call	TimerCh2
		jmp	AY1415

SoundProcInt:
		push	psw
		push	b
		push	d
		push	h
;  
		lda	AY_R13
		ani	00001111b
		lxi	h,Env
		call	add_hl_a
		mov	a,m
		ora	a
		jnz	Exit			; "" ,  
;  "",    
		lda	EnvPeriod
		ora	a
		jz	Exit			;   	0,  
		lxi	h, EnvPeriodCount
		dcr	m
		jnz	Exit
		xra	a
		sta	EnvPeriod		;   
; 
		lda	AY_R8
		ora	a
		jz	EnvCh1
		mvi	a, 36h		;  0
		sta	SOUNDM
		jmp	Exit
EnvCh1:
		lda	AY_R9
		ora	a
		jz	EnvCh2
		mvi	a, 36h		;  1
		sta	SOUNDM
		jmp	Exit
EnvCh2:
		lda	AY_R10
		ora	a
		jz	Exit
		mvi	a, 36h		;  2
		sta	SOUNDM

Exit:
		mvi	a, 20h
		sta	SICP0
		pop	h
		pop	d
		pop	b
		pop	psw
		ei
		ret

;,   ""   0
Env:		.db 0,0,0,0
		.db 0,0,0,0
		.db 1,0,1,1
		.db 1,1,1,0

AY_R0:		.db 1
AY_R1:		.db 1
AY_R2:		.db 1
AY_R3:		.db 1
AY_R4:		.db 1
AY_R5:		.db 1
AY_R6:		.db 1
;      
AY_R8:		.db 0
AY_R9:		.db 0
AY_R10:		.db 0

AY_R12:		.db 1
AY_R13:		.db 0
AY_R7_Process:	.db 0FFh
					;  	R7
					;   3   / 
EnvPeriod:		.db 0
AY_R7_Noise:	.db 0
					;   3-5  
					; /  
EnvPeriodCount:	.db 0


add_hl_a:
		add	l
		mov	l, a
		rnc
		inr	h
		ret
; End of function add_hl_a


		.end
